<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__scb__uart" kind="group">
    <compoundname>group_scb_uart</compoundname>
    <title>UART (SCB)</title>
    <innergroup refid="group__group__scb__uart__macros">Macros</innergroup>
    <innergroup refid="group__group__scb__uart__functions">Functions</innergroup>
    <innergroup refid="group__group__scb__uart__data__structures">Data Structures</innergroup>
    <innergroup refid="group__group__scb__uart__enums">Enumerated Types</innergroup>
    <briefdescription>
<para>Driver API for UART. </para>    </briefdescription>
    <detaileddescription>
<para>The functions and other declarations used in this part of the driver are in cy_scb_uart.h. You can also include cy_pdl.h to get access to all functions and declarations in the PDL.</para><para>The Universal Asynchronous Receiver/Transmitter (UART) protocol is an asynchronous serial interface protocol. UART communication is typically point-to-point. The UART interface consists of two signals:<itemizedlist>
<listitem><para>TX: Transmitter output</para></listitem><listitem><para>RX: Receiver input</para></listitem></itemizedlist>
</para><para>Additionally, two side-band signals are used to implement flow control in UART. Note that the flow control applies only to TX functionality.<itemizedlist>
<listitem><para>Clear to Send (CTS): This is an input signal to the transmitter. When active, it indicates that the slave is ready for the master to transmit data.</para></listitem><listitem><para>Ready to Send (RTS): This is an output signal from the receiver. When active, it indicates that the receiver is ready to receive data</para></listitem></itemizedlist>
</para><para>Features:<itemizedlist>
<listitem><para>Supports UART protocol<itemizedlist>
<listitem><para>Standard UART</para></listitem><listitem><para>Multi-processor mode</para></listitem></itemizedlist>
</para></listitem><listitem><para>SmartCard (ISO7816) reader</para></listitem><listitem><para>IrDA</para></listitem><listitem><para>Data frame size programmable from 4 to 16 bits</para></listitem><listitem><para>Programmable number of STOP bits, which can be set in terms of half bit periods between 1 and 4</para></listitem><listitem><para>Parity support (odd and even parity)</para></listitem><listitem><para>Median filter on Rx input</para></listitem><listitem><para>Programmable oversampling</para></listitem><listitem><para>Start skipping</para></listitem></itemizedlist>
</para>
<para><heading level="1">Configuration Considerations</heading></para>
<para>The UART driver configuration can be divided to number of sequential steps listed below:<itemizedlist>
<listitem><para><ref kindref="member" refid="group__group__scb__uart_1group_scb_uart_config">Configure UART</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__scb__uart_1group_scb_uart_pins">Assign and Configure Pins</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__scb__uart_1group_scb_uart_clock">Assign Clock Divider</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__scb__uart_1group_scb_uart_data_rate">Configure Baud Rate</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__scb__uart_1group_scb_uart_intr">Configure Interrupt</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__scb__uart_1group_scb_uart_enable">Enable UART</ref></para></listitem></itemizedlist>
</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;UART driver is built on top of the SCB hardware block. The SCB5 instance is used as an example for all code snippets. Modify the code to match your design.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
<para><bold>Configure UART</bold></para>
<para>To set up the UART driver, provide the configuration parameters in the <ref kindref="compound" refid="structcy__stc__scb__uart__config__t">cy_stc_scb_uart_config_t</ref> structure. For example: provide uartMode, oversample, dataWidth, enableMsbFirst, parity, and stopBits. The other parameters are optional. To initialize the driver, call <ref kindref="member" refid="group__group__scb__uart__general__functions_1gacbc061f623d2fafbcfffcb58c5f2db51">Cy_SCB_UART_Init</ref> function providing a pointer to the populated <ref kindref="compound" refid="structcy__stc__scb__uart__config__t">cy_stc_scb_uart_config_t</ref> structure and the allocated <ref kindref="compound" refid="structcy__stc__scb__uart__context__t">cy_stc_scb_uart_context_t</ref> structure.</para><para><programlisting><codeline><highlight class="comment">/*<sp />Allocate<sp />context<sp />for<sp />UART<sp />operation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__scb__uart__context__t">cy_stc_scb_uart_context_t</ref><sp />uartContext;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Populate<sp />configuration<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__scb__uart__config__t">cy_stc_scb_uart_config_t</ref><sp />uartConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcy__stc__scb__uart__config__t_1ae3ffcd78ef51b5dd068bd87ef129d78e">uartMode</ref><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /><ref kindref="member" refid="group__group__scb__uart__enums_1ggaff3a50e4dbd1e0efe1550b05816e1a65a039e9ca2ab60fb9e0d2226bd21e4787c">CY_SCB_UART_STANDARD</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.enableMutliProcessorMode<sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.smartCardRetryOnNack<sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.irdaInvertRx<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.irdaEnableLowPowerReceiver<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.oversample<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />12UL,</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.enableMsbFirst<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.dataWidth<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />8UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.parity<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /><ref kindref="member" refid="group__group__scb__uart__enums_1gga5ee6d587ef3399954d609f17775a3f42a4684fcd6cd3d48bf9372f5947af95f0d">CY_SCB_UART_PARITY_NONE</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.stopBits<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /><ref kindref="member" refid="group__group__scb__uart__enums_1gga980f6c273a50db8f6b6fa7f703b1a7f9ac35384addc6b2590f3ec209ae4541394">CY_SCB_UART_STOP_BITS_1</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.enableInputFilter<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.breakWidth<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />11UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.dropOnFrameError<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.dropOnParityError<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.receiverAddress<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.receiverAddressMask<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.acceptAddrInFifo<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.enableCts<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.ctsPolarity<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /><ref kindref="member" refid="group__group__scb__uart__enums_1ggadd7a3cc34b487e9898095db7b1638098a61a976af6edbc286fc87ee17b3809f36">CY_SCB_UART_ACTIVE_LOW</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.rtsRxFifoLevel<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.rtsPolarity<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp /><ref kindref="member" refid="group__group__scb__uart__enums_1ggadd7a3cc34b487e9898095db7b1638098a61a976af6edbc286fc87ee17b3809f36">CY_SCB_UART_ACTIVE_LOW</ref>,</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.rxFifoTriggerLevel<sp /><sp />=<sp />0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.rxFifoIntEnableMask<sp />=<sp />0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.txFifoTriggerLevel<sp /><sp />=<sp />0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.txFifoIntEnableMask<sp />=<sp />0UL,</highlight></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Configure<sp />UART<sp />to<sp />operate<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">(void)<sp /><ref kindref="member" refid="group__group__scb__uart__general__functions_1gacbc061f623d2fafbcfffcb58c5f2db51">Cy_SCB_UART_Init</ref>(SCB5,<sp />&amp;uartConfig,<sp />&amp;uartContext);</highlight></codeline>
</programlisting></para>

<para><bold>Assign and Configure Pins</bold></para>
<para>Only dedicated SCB pins can be used for UART operation. The HSIOM register must be configured to connect dedicated SCB UART pins to the SCB block. Also, the UART output pins must be configured in Strong Drive Input Off mode and UART input pins in Digital High-Z:</para><para><programlisting><codeline><highlight class="comment">/*<sp />Assign<sp />pins<sp />for<sp />UART<sp />on<sp />SCB5:<sp />P5[0],<sp />P5[1]<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />UART_PORT<sp /><sp /><sp /><sp /><sp /><sp /><sp />P5_0_PORT</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />UART_RX_NUM<sp /><sp /><sp /><sp /><sp />P5_0_NUM</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />UART_TX_NUM<sp /><sp /><sp /><sp /><sp />P5_1_NUM</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Connect<sp />SCB5<sp />UART<sp />function<sp />to<sp />pins<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__gpio__functions__init_1ga83a06264feed0e1042671a74339ea155">Cy_GPIO_SetHSIOM</ref>(UART_PORT,<sp />UART_RX_NUM,<sp />P5_0_SCB5_UART_RX);</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__gpio__functions__init_1ga83a06264feed0e1042671a74339ea155">Cy_GPIO_SetHSIOM</ref>(UART_PORT,<sp />UART_TX_NUM,<sp />P5_1_SCB5_UART_TX);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Configure<sp />pins<sp />for<sp />UART<sp />operation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__gpio__functions__gpio_1ga97e64dc8c45e7cd73e3012100d03b1fd">Cy_GPIO_SetDrivemode</ref>(UART_PORT,<sp />UART_RX_NUM,<sp /><ref kindref="member" refid="group__group__gpio__drive_modes_1gaf2fe5dc00ba1770b37e620a01169485c">CY_GPIO_DM_HIGHZ</ref>);</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__gpio__functions__gpio_1ga97e64dc8c45e7cd73e3012100d03b1fd">Cy_GPIO_SetDrivemode</ref>(UART_PORT,<sp />UART_TX_NUM,<sp /><ref kindref="member" refid="group__group__gpio__drive_modes_1gacebd8bea6222d742bdfbfd86dabab940">CY_GPIO_DM_STRONG_IN_OFF</ref>);</highlight></codeline>
</programlisting></para>

<para><bold>Assign Clock Divider</bold></para>
<para>A clock source must be connected to the SCB block to oversample input and output signals, in this document this clock will be referred as clk_scb. You must use one of available integer or fractional dividers. Use the <ref kindref="compound" refid="group__group__sysclk">SysClk (System Clock)</ref> driver API to do this.</para><para><programlisting><codeline><highlight class="comment">/*<sp />Assign<sp />divider<sp />type<sp />and<sp />number<sp />for<sp />UART<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />UART_CLK_DIV_TYPE<sp /><sp /><sp /><sp /><sp />(CY_SYSCLK_DIV_8_BIT)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />UART_CLK_DIV_NUMBER<sp /><sp /><sp />(0U)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Connect<sp />assigned<sp />divider<sp />to<sp />be<sp />a<sp />clock<sp />source<sp />for<sp />UART<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1gacb66324e3191006f6d1cee8b29238fb2">Cy_SysClk_PeriphAssignDivider</ref>(PCLK_SCB5_CLOCK,<sp />UART_CLK_DIV_TYPE,<sp />UART_CLK_DIV_NUMBER);</highlight></codeline>
</programlisting></para>

<para><bold>Configure Baud Rate</bold></para>
<para>To get the UART to operate with the desired baud rate, the clk_scb frequency and the oversample must be configured. Use the <ref kindref="compound" refid="group__group__sysclk">SysClk (System Clock)</ref> driver API to configure clk_scb frequency. Set the <emphasis><bold>oversample parameter in configuration structure</bold></emphasis> to define the number of the SCB clocks within one UART bit-time.</para><para><programlisting><codeline><highlight class="comment">/*<sp />UART<sp />desired<sp />baud<sp />rate<sp />is<sp />115200<sp />bps<sp />(Standard<sp />mode).</highlight></codeline>
<codeline><highlight class="comment">*<sp />The<sp />UART<sp />baud<sp />rate<sp />=<sp />(clk_scb<sp />/<sp />Oversample).</highlight></codeline>
<codeline><highlight class="comment">*<sp />For<sp />clk_peri<sp />=<sp />50<sp />MHz,<sp />select<sp />divider<sp />value<sp />36<sp />and<sp />get<sp />SCB<sp />clock<sp />=<sp />(50<sp />MHz<sp />/<sp />36)<sp />=<sp />1,389<sp />MHz.</highlight></codeline>
<codeline><highlight class="comment">*<sp />Select<sp />Oversample<sp />=<sp />12.<sp />These<sp />setting<sp />results<sp />UART<sp />data<sp />rate<sp />=<sp />1,389<sp />MHz<sp />/<sp />12<sp />=<sp />115750<sp />bps.</highlight></codeline>
<codeline><highlight class="comment">*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1gac67931844e6ec06b5ff88f4f3119e127">Cy_SysClk_PeriphSetDivider</ref><sp /><sp /><sp />(UART_CLK_DIV_TYPE,<sp />UART_CLK_DIV_NUMBER,<sp />35UL);</highlight></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1ga8c626f11b583d8296516bbcf4a22f98e">Cy_SysClk_PeriphEnableDivider</ref>(UART_CLK_DIV_TYPE,<sp />UART_CLK_DIV_NUMBER);</highlight></codeline>
</programlisting> <bold>Refer to the technical reference manual (TRM) section UART sub-section Clocking and Oversampling to get information about how to configure the UART to run with desired baud rate.</bold></para>

<para><bold>Configure Interrupt</bold></para>
<para>The interrupt is optional for the UART operation. To configure interrupt the <ref kindref="member" refid="group__group__scb__uart__interrupt__functions_1ga3e1928d8f20b2685aad02df29b658e3f">Cy_SCB_UART_Interrupt</ref> function must be called in the interrupt handler for the selected SCB instance. Also, this interrupt must be enabled in the NVIC. The interrupt must be configured when <ref kindref="member" refid="group__group__scb__uart_1group_scb_uart_hl">High-Level API</ref> will be used.</para><para><programlisting><codeline><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />UART_Isr(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__scb__uart__interrupt__functions_1ga3e1928d8f20b2685aad02df29b658e3f">Cy_SCB_UART_Interrupt</ref>(SCB5,<sp />&amp;uartContext);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting><programlisting><codeline><highlight class="comment">/*<sp />Assign<sp />UART<sp />interrupt<sp />number<sp />and<sp />priority<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />UART_INTR_NUM<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((IRQn_Type)<sp />scb_5_interrupt_IRQn)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />UART_INTR_PRIORITY<sp /><sp /><sp />(7U)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Populate<sp />configuration<sp />structure<sp />(code<sp />specific<sp />for<sp />CM4)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__sysint__t">cy_stc_sysint_t</ref><sp />uartIntrConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcy__stc__sysint__t_1a6da08d81da65a7f93d3e4c46a4b8d950">intrSrc</ref><sp /><sp /><sp /><sp /><sp /><sp />=<sp />UART_INTR_NUM,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />.intrPriority<sp />=<sp />UART_INTR_PRIORITY,</highlight></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Hook<sp />interrupt<sp />service<sp />routine<sp />and<sp />enable<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">(void)<sp /><ref kindref="member" refid="group__group__sysint__functions_1gab2ff6820a898e9af3f780000054eea5d">Cy_SysInt_Init</ref>(&amp;uartIntrConfig,<sp />&amp;UART_Isr);</highlight></codeline>
<codeline><highlight class="normal">NVIC_EnableIRQ(UART_INTR_NUM);</highlight></codeline>
</programlisting></para>

<para><bold>Enable UART</bold></para>
<para>Finally, enable the UART operation by calling <ref kindref="member" refid="group__group__scb__uart__general__functions_1ga503d0737dadf35620306ef3571d84905">Cy_SCB_UART_Enable</ref>.</para><para><programlisting><codeline><highlight class="comment">/*<sp />Enable<sp />UART<sp />to<sp />operate<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__scb__uart__general__functions_1ga503d0737dadf35620306ef3571d84905">Cy_SCB_UART_Enable</ref>(SCB5);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Enable<sp />global<sp />interrupts<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">__enable_irq();</highlight></codeline>
</programlisting></para>


<para><heading level="1">Common Use Cases</heading></para>
<para>The UART API is divided into two categories: <ref kindref="compound" refid="group__group__scb__uart__low__level__functions">Low-Level</ref> and <ref kindref="compound" refid="group__group__scb__uart__high__level__functions">High-Level</ref>. <linebreak />
<emphasis>Do not mix <bold>High-Level</bold> and <bold>Low-Level</bold> API because a Low-Level API can adversely affect the operation of a High-Level API.</emphasis></para>
<para><bold>Low-Level API</bold></para>
<para>The <ref kindref="compound" refid="group__group__scb__uart__low__level__functions">Low-Level</ref> functions allow interacting directly with the hardware and do not use <ref kindref="member" refid="group__group__scb__uart__interrupt__functions_1ga3e1928d8f20b2685aad02df29b658e3f">Cy_SCB_UART_Interrupt</ref>. These functions do not require context for operation. Thus, NULL can be passed for context parameter in <ref kindref="member" refid="group__group__scb__uart__general__functions_1gacbc061f623d2fafbcfffcb58c5f2db51">Cy_SCB_UART_Init</ref> and <ref kindref="member" refid="group__group__scb__uart__general__functions_1ga2a07f58f9a898202d43bc3b14caab2de">Cy_SCB_UART_Disable</ref> instead of a pointer to the context structure.</para><para><itemizedlist>
<listitem><para>To write data into the TX FIFO, use one of the provided functions: <ref kindref="member" refid="group__group__scb__uart__low__level__functions_1gae8eba8924ed4b8add6e7cabdf25a18fe">Cy_SCB_UART_Put</ref>, <ref kindref="member" refid="group__group__scb__uart__low__level__functions_1ga242ad51b987fa6ccfc23f3471182ce36">Cy_SCB_UART_PutArray</ref>, <ref kindref="member" refid="group__group__scb__uart__low__level__functions_1gac709dbaa61ae25a05086124f1ffaa0d7">Cy_SCB_UART_PutArrayBlocking</ref> or <ref kindref="member" refid="group__group__scb__uart__low__level__functions_1ga4092c34575a47087e08a58529451914b">Cy_SCB_UART_PutString</ref>. Note that putting data into the TX FIFO starts data transfer.</para></listitem><listitem><para>To read data from the RX FIFO, use one of the provided functions: <ref kindref="member" refid="group__group__scb__uart__low__level__functions_1ga86ab3686a98a0e215c1f2eeed3ce254f">Cy_SCB_UART_Get</ref>, <ref kindref="member" refid="group__group__scb__uart__low__level__functions_1ga509c3f8c4acd406d4253019d28a0eb3a">Cy_SCB_UART_GetArray</ref> or <ref kindref="member" refid="group__group__scb__uart__low__level__functions_1ga7d45f3f8f625e2f16341a03a4078698e">Cy_SCB_UART_GetArrayBlocking</ref>.</para></listitem><listitem><para>The statuses can be polled using: <ref kindref="member" refid="group__group__scb__uart__low__level__functions_1gaa2d783e45d8b8a9803bb5b667d71f3b9">Cy_SCB_UART_GetRxFifoStatus</ref> and <ref kindref="member" refid="group__group__scb__uart__low__level__functions_1ga76218bc016256d8525c9d779a4c2e9aa">Cy_SCB_UART_GetTxFifoStatus</ref>. <emphasis>The statuses are <bold>W1C (Write 1 to Clear)</bold> and after a status is set, it must be cleared.</emphasis> Note that there are statuses evaluated as level. These statuses remain set until an event is true. Therefore, after the clear operation, the status is cleared but then it is restored (if event is still true). Also, the following functions can be used for polling as well <ref kindref="member" refid="group__group__scb__uart__low__level__functions_1ga81aff78dcdc266d6cac81e714afef6c3">Cy_SCB_UART_IsTxComplete</ref>, <ref kindref="member" refid="group__group__scb__uart__low__level__functions_1gabc4b66b875dbc70d52adf19170d3a530">Cy_SCB_UART_GetNumInRxFifo</ref> and <ref kindref="member" refid="group__group__scb__uart__low__level__functions_1ga0f264dad00ca5fcdf668f20e35e4fcab">Cy_SCB_UART_GetNumInTxFifo</ref>.</para></listitem></itemizedlist>
</para><para><programlisting><codeline><highlight class="normal">uint8_t<sp />txBuffer[BUFFER_SIZE];</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Initialize<sp />txBuffer<sp />with<sp />command<sp />to<sp />transfer<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">txBuffer[0]<sp />=<sp />CMD_START_TRANSFER;</highlight></codeline>
<codeline><highlight class="normal">txBuffer[1]<sp />=<sp />0x00U;</highlight></codeline>
<codeline><highlight class="normal">txBuffer[2]<sp />=<sp />0x01U;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Master:<sp />start<sp />a<sp />transfer.<sp />Slave:<sp />prepare<sp />for<sp />a<sp />transfer.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="member" refid="group__group__scb__uart__low__level__functions_1gac709dbaa61ae25a05086124f1ffaa0d7">Cy_SCB_UART_PutArrayBlocking</ref>(SCB5,<sp />txBuffer,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(txBuffer));</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Blocking<sp />wait<sp />for<sp />transfer<sp />completion<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordflow">while</highlight><highlight class="normal"><sp />(!<ref kindref="member" refid="group__group__scb__uart__low__level__functions_1ga81aff78dcdc266d6cac81e714afef6c3">Cy_SCB_UART_IsTxComplete</ref>(SCB5))</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para>

<para><bold>High-Level API</bold></para>
<para>The <ref kindref="compound" refid="group__group__scb__uart__high__level__functions">High-Level</ref> API use <ref kindref="member" refid="group__group__scb__uart__interrupt__functions_1ga3e1928d8f20b2685aad02df29b658e3f">Cy_SCB_UART_Interrupt</ref> to execute the transfer. Call <ref kindref="member" refid="group__group__scb__uart__high__level__functions_1ga12cc7712f9cb5e26b28d1d9a3a9576b4">Cy_SCB_UART_Transmit</ref> to start transmission. Call <ref kindref="member" refid="group__group__scb__uart__high__level__functions_1gace7421c664f582ab4ad4bade0683f209">Cy_SCB_UART_Receive</ref> to start receive operation. After the operation is started the <ref kindref="member" refid="group__group__scb__uart__interrupt__functions_1ga3e1928d8f20b2685aad02df29b658e3f">Cy_SCB_UART_Interrupt</ref> handles the data transfer until its completion. Therefore <ref kindref="member" refid="group__group__scb__uart__interrupt__functions_1ga3e1928d8f20b2685aad02df29b658e3f">Cy_SCB_UART_Interrupt</ref> must be called inside the user interrupt handler to make the High-Level API work. To monitor status of transmit operation, use <ref kindref="member" refid="group__group__scb__uart__high__level__functions_1ga92ea29d41db81f995b0ff442d6639191">Cy_SCB_UART_GetTransmitStatus</ref> and <ref kindref="member" refid="group__group__scb__uart__high__level__functions_1ga4cc7bd2f28ef5e170e663414dba66f8c">Cy_SCB_UART_GetReceiveStatus</ref> to monitor receive status appropriately. Alternatively use <ref kindref="member" refid="group__group__scb__uart__interrupt__functions_1gaa14dc3c4f0e5680fbc543d3115eac839">Cy_SCB_UART_RegisterCallback</ref> to register callback function to be notified about <ref kindref="compound" refid="group__group__scb__uart__macros__callback__events">UART Callback Events</ref>.</para><para><bold>Receive Operation</bold> <programlisting><codeline><highlight class="normal">uint8_t<sp />rxBuffer[BUFFER_SIZE];</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Start<sp />receive<sp />operation<sp />(do<sp />not<sp />check<sp />status)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">(void)<sp /><ref kindref="member" refid="group__group__scb__uart__high__level__functions_1gace7421c664f582ab4ad4bade0683f209">Cy_SCB_UART_Receive</ref>(SCB5,<sp />rxBuffer,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(rxBuffer),<sp />&amp;uartContext);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Blocking<sp />wait<sp />until<sp />buffer<sp />is<sp />full<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordflow">while</highlight><highlight class="normal"><sp />(0UL<sp />!=<sp />(<ref kindref="member" refid="group__group__scb__uart__macros__receive__status_1ga5ddb60f6cf8432fb0e2bc15b1a353902">CY_SCB_UART_RECEIVE_ACTIVE</ref><sp />&amp;<sp /><ref kindref="member" refid="group__group__scb__uart__high__level__functions_1ga4cc7bd2f28ef5e170e663414dba66f8c">Cy_SCB_UART_GetReceiveStatus</ref>(SCB5,<sp />&amp;uartContext)))</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Handle<sp />received<sp />data<sp />*/</highlight><highlight class="normal" /></codeline>
</programlisting> <bold>Transmit Operation</bold> <programlisting><codeline><highlight class="normal">uint8_t<sp />txBuffer[BUFFER_SIZE];</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Initialize<sp />txBuffer<sp />with<sp />data<sp />to<sp />transfer<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">txBuffer[0]<sp />=<sp />CMD_START_TRANSFER;</highlight></codeline>
<codeline><highlight class="normal">txBuffer[1]<sp />=<sp />0x00U;</highlight></codeline>
<codeline><highlight class="normal">txBuffer[2]<sp />=<sp />0x01U;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Start<sp />transmit<sp />operation<sp />(do<sp />not<sp />check<sp />status)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">(void)<sp /><ref kindref="member" refid="group__group__scb__uart__high__level__functions_1ga12cc7712f9cb5e26b28d1d9a3a9576b4">Cy_SCB_UART_Transmit</ref>(SCB5,<sp />txBuffer,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(txBuffer),<sp />&amp;uartContext);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Blocking<sp />wait<sp />for<sp />transmission<sp />completion<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordflow">while</highlight><highlight class="normal"><sp />(0UL<sp />!=<sp />(<ref kindref="member" refid="group__group__scb__uart__macros__transmit__status_1gaa640df2a6637fd851cfcce6665ba93f1">CY_SCB_UART_TRANSMIT_ACTIVE</ref><sp />&amp;<sp /><ref kindref="member" refid="group__group__scb__uart__high__level__functions_1ga92ea29d41db81f995b0ff442d6639191">Cy_SCB_UART_GetTransmitStatus</ref>(SCB5,<sp />&amp;uartContext)))</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> There is also capability to insert a receive ring buffer that operates between the RX FIFO and the user buffer. The received data is copied into the ring buffer from the RX FIFO. This process runs in the background after the ring buffer operation is started by <ref kindref="member" refid="group__group__scb__uart__high__level__functions_1gaf31baac4127fbab570f27bde1df9c622">Cy_SCB_UART_StartRingBuffer</ref>. When <ref kindref="member" refid="group__group__scb__uart__high__level__functions_1gace7421c664f582ab4ad4bade0683f209">Cy_SCB_UART_Receive</ref> is called, it first reads data from the ring buffer and then sets up an interrupt to receive more data if the required amount has not yet been read.</para>


<para><heading level="1">DMA Trigger</heading></para>
<para>The SCB provides TX and RX output trigger signals that can be routed to the DMA controller inputs. These signals are assigned based on the data availability in the TX and RX FIFOs appropriately.</para><para><itemizedlist>
<listitem><para>The RX trigger signal is active while the number of data elements in the RX FIFO is greater than the value of RX FIFO level. Use function <ref kindref="member" refid="group__group__scb__common__functions_1ga64d034531ea5eb2695ed018d6a75da68">Cy_SCB_SetRxFifoLevel</ref> or set configuration structure rxFifoTriggerLevel parameter to configure RX FIFO level value. <linebreak />
 <emphasis>For example, the RX FIFO has 8 data elements and the RX FIFO level is 0. The RX trigger signal is active until DMA reads all data from the RX FIFO.</emphasis></para></listitem><listitem><para>The TX trigger signal is active while the number of data elements in the TX FIFO is less than the value of TX FIFO level. Use function <ref kindref="member" refid="group__group__scb__common__functions_1ga36285e337c94df91a4ebe5b1ee0fd43d">Cy_SCB_SetTxFifoLevel</ref> or set configuration structure txFifoTriggerLevel parameter to configure TX FIFO level value. <linebreak />
 <emphasis>For example, the TX FIFO has 0 data elements (empty) and the TX FIFO level is 7. The TX trigger signal is active until DMA loads TX FIFO with 8 data elements (note that after the first TX load operation, the data element goes to the shift register and TX FIFO is empty).</emphasis></para></listitem></itemizedlist>
</para><para>To route SCB TX or RX trigger signals to DMA controller use <ref kindref="compound" refid="group__group__trigmux">TrigMux (Trigger Multiplexer)</ref> driver API.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;To properly handle DMA level request signal activation and de-activation from the SCB peripheral block the DMA Descriptor typically must be configured to re-trigger after 16 Clk_Slow cycles.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

<para><heading level="1">Low Power Support</heading></para>
<para>The UART driver provides callback functions to handle power mode transition. The callback <ref kindref="member" refid="group__group__scb__uart__low__power__functions_1gaa26ee4aa1c2ac9fb98daddbfe6e151aa">Cy_SCB_UART_DeepSleepCallback</ref> must be called during execution of <ref kindref="member" refid="group__group__syspm__functions__power_1ga5150c28fe4d2626720c1fbf74b3111ca">Cy_SysPm_CpuEnterDeepSleep</ref> <ref kindref="member" refid="group__group__scb__uart__low__power__functions_1gad72ab6609be39108f73aea440d229bce">Cy_SCB_UART_HibernateCallback</ref> must be called during execution of <ref kindref="member" refid="group__group__syspm__functions__power_1gae97647a28c370674ba57d451d21d1c51">Cy_SysPm_SystemEnterHibernate</ref>. To trigger the callback execution, the callback must be registered before calling the power mode transition function. Refer to <ref kindref="compound" refid="group__group__syspm">SysPm (System Power Management)</ref> driver for more information about power mode transitions and callback registration.</para><para>The UART is disabled during Deep Sleep and Hibernate and stops driving the output pins. The state of the UART output pins TX and RTS is High-Z, which can cause unexpected behavior of the UART receiver due to possible glitches on these lines. These pins must be set to the inactive state before entering Deep Sleep or Hibernate mode. These pins must keep the inactive level (the same state when UART TX is enabled and does not transfer data) before entering Deep Sleep or Hibernate mode. To do that, write the GPIO data register of each pin to the inactive level for each output pin. Then configure High-Speed Input Output Multiplexer (HSIOM) of each pin to be controlled by the GPIO (use <ref kindref="compound" refid="group__group__gpio">GPIO (General Purpose Input Output)</ref> driver API). After exiting Deep Sleep mode the UART must be enabled and the pins configuration restored to return the UART control of the pins (after exiting Hibernate mode, the system initialization code does the same). Copy either or both <ref kindref="member" refid="group__group__scb__uart__low__power__functions_1gaa26ee4aa1c2ac9fb98daddbfe6e151aa">Cy_SCB_UART_DeepSleepCallback</ref> and <ref kindref="member" refid="group__group__scb__uart__low__power__functions_1gad72ab6609be39108f73aea440d229bce">Cy_SCB_UART_HibernateCallback</ref> as appropriate, and make the changes described above inside the function. Alternately, external pull-up or pull-down resistors can be connected to the appropriate UART lines to keep them inactive during Deep-Sleep or Hibernate. </para>
    </detaileddescription>
  </compounddef>
</doxygen>